<?php

/*
+---------------------------------------------------------------------------+
| Revive Adserver                                                           |
| http://www.revive-adserver.com                                            |
|                                                                           |
| Copyright: See the COPYRIGHT.txt file.                                    |
| License: GPLv2 or later, see the LICENSE.txt file.                        |
+---------------------------------------------------------------------------+
*/

/**
 * @package    OpenXPlugin
 * @subpackage InvocationTags
 *
 */

require_once LIB_PATH . '/Extension/invocationTags/InvocationTags.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';

/**
 *
 * Invocation tag plugin.
 *
 */
class Plugins_InvocationTags_OxInvocationTags_textasync extends Plugins_InvocationTags implements \RV\Extension\InvocationTags\WebsiteInvocationInterface
{
    /**
     * Set default values for options used by this plugin
     *
     * @var array Array of $key => $defaultValue
     */
    private $defaultOptionValues = [
        'block' => 0,
        'blockcampaign' => 0,
        'target' => '',
        'source' => '',
    ];

    /**
     * Return name of plugin
     *
     * @return string
     */
    public function getName()
    {
        return $this->translate("Google like Textad Asynchronous Tag");
    }

    /**
     * Return the English name of the plugin. Used when
     * generating translation keys based on the plugin
     * name.
     *
     * @return string An English string describing the class.
     */
    public function getNameEN()
    {
        return 'Google like Textad Asynchronous Tag';
    }

    /**
     * Check if plugin is allowed
     *
     * @return boolean  True - allowed, false - not allowed
     */
    public function isAllowed($extra = null)
    {
        return true;
    }

    public function getOrder()
    {
        parent::getOrder();
        return 34;
    }

    /**
     * Return list of options
     *
     * @return array    Group of options
     */
    public function getOptionsList()
    {
        if (is_array($this->defaultOptions)) {
            unset($this->defaultOptions['cacheBuster']);
            unset($this->defaultOptions['comments']);
            unset($this->defaultOptions['https']);
        }
        $options = [
            'block' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'blockcampaign' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'target' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
            'source' => MAX_PLUGINS_INVOCATION_TAGS_STANDARD,
			'textFont'	    => 1,
			'LinkFont'	=> 1,	
			'HeaderFont'    => 1,	
			'bordercolor'   => 1,
			'Linkcolor'	=> 1,
			'headingcolor'   => 1,	
			'FontSize'	=> 1,
			'Textsize'		=> 1,  
			'HeaderFontSize'	=> 1,
			'HeaderTextStyle'	=> 1,
			'TextStyle'	=> 1, 
        ];

        return $options;
    }
       
    // Reviveadservermod.com - Text Ads start
    public function textFont()
    {
		$maxInvocation = &$this->maxInvocation;

		$textFont = (!empty($maxInvocation->textFont)) ? $maxInvocation->textFont : $this->defaultValues['textFont'];
		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>
		<td width='200'>Text Font</td><td width='370'>
		<select name='textFont' tabindex='".($maxInvocation->tabindex++)."'>
		<option value=''>Default</option>
		<option value='Arial, Helvetica, sans-serif'" . ($textFont == 'Arial,Helvetica,sans-serif' ? " selected='selected'" : '') . ">Arial,Helvetica,sans-serif</option>
		<option value='Arial Black,Gadget,sans-serif'" . ($textFont == 'Arial Black,Gadget,sans-serif' ? " selected='selected'" : '') . ">Arial Black,Gadget,sans-serif</option>
		<option value='Comic Sans MS,cursive'" . ($textFont == 'Comic Sans MS,cursive' ? " selected='selected'" : '') . ">Comic Sans MS,cursive</option>
		<option value='Courier New,Courier,monospace'" . ($textFont == 'Courier New,Courier,monospace' ? " selected='selected'" : '') . ">Courier New,Courier,monospace</option>
		<option value='Georgia,serif'" . ($textFont == 'Georgia,serif' ? " selected='selected'" : '') . ">Georgia,serif</option>
		<option value='Impact,Charcoal,sans-serif'" . ($textFont == 'Impact,Charcoal,sans-serif' ? " selected='selected'" : '') . ">Impact,Charcoal,sans-serif</option>
		<option value='Lucida Console,Monaco,monospace'" . ($textFont == 'Lucida Console,Monaco,monospace' ? " selected='selected'" : '') . ">Lucida Console,Monaco,monospace</option>
		<option value='Lucida Sans Unicode,Lucida Grande,sans-serif'" . ($textFont == 'Lucida Sans Unicode,Lucida Grande,sans-serif' ? " selected='selected'" : '') . ">Lucida Sans Unicode,Lucida Grande,sans-serif</option>
		<option value='Palatino Linotype,Book Antiqua,Palatino,serif'" . ($textFont == 'APalatino Linotype,Book Antiqua,Palatino,serif' ? " selected='selected'" : '') . ">Palatino Linotype,Book Antiqua,Palatino,serif</option>
		<option value='Tahoma,Geneva,sans-serif'" . ($textFont == 'Tahoma,Geneva,sans-serif' ? " selected='selected'" : '') . ">Tahoma,Geneva,sans-serif</option>
		<option value='Times New Roman,Times,serif'" . ($textFont == 'Times New Roman,Times,serif' ? " selected='selected'" : '') . ">Times New Roman,Times,serif</option>		
		<option value='Trebuchet MS,Helvetica,sans-serif'" . ($textFont == 'Trebuchet MS,Helvetica,sans-serif' ? " selected='selected'" : '') . ">TTrebuchet MS,Helvetica,sans-serif</option>
		<option value='Verdana,Geneva,sans-serif'" . ($textFont == 'Verdana,Geneva,sans-serif' ? " selected='selected'" : '') . ">Verdana,Geneva,sans-serif</option>
		<option value='Symbol'" . ($textFont == 'Symbol' ? " selected='selected'" : '') . ">Symbol</option>
		<option value='Webdings'" . ($textFont == 'Webdings' ? " selected='selected'" : '') . ">Webdings</option>
		<option value='Wingdings,Zapf Dingbats'" . ($textFont == 'Wingdings,Zapf Dingbats' ? " selected='selected'" : '') . ">Wingdings,Zapf Dingbats</option>
		<option value='MS Sans Serif, Geneva, sans-serif'" . ($textFont == 'MS Sans Serif, Geneva, sans-serif' ? " selected='selected'" : '') . ">MS Sans Serif, Geneva, sans-serif</option>

		<option value='MS Serif, New York, serif'" . ($textFont == 'MS Serif, New York, serif' ? " selected='selected'" : '') . ">MS Serif, New York, serif</option>
		<option value='arial narrow'" . ($textFont == 'arial narrow' ? " selected='selected'" : '') . ">arial narrow</option>
		<option value='verdan'" . ($textFont == 'verdan' ? " selected='selected'" : '') . ">verdan</option>
		</select>
		<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

		return $option;
	
    }

	public function TextStyle()
    {
		$maxInvocation = &$this->maxInvocation;
		$TextStyle = (!empty($maxInvocation->TextStyle)) ? $maxInvocation->TextStyle : $this->defaultValues['TextStyle'];
		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>
		<td width='200'>Text Style</td><td width='370'>
		<select name='TextStyle' tabindex='".($maxInvocation->tabindex++)."'>
		<option value=''>Default</option>
		<option value='italic'" . ($TextStyle == 'italic' ? " selected='selected'" : '') . ">italic</option>
		<option value='normal'" . ($TextStyle == 'normal' ? " selected='selected'" : '') . ">normal</option>
		<option value='oblique'" . ($TextStyle == 'oblique' ? " selected='selected'" : '') . ">oblique</option>

		</select>
		<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

		return $option;
	
    }

	public function HeaderTextStyle()
    {
		$maxInvocation = &$this->maxInvocation;
		$HeaderTextStyle = (!empty($maxInvocation->HeaderTextStyle)) ? $maxInvocation->HeaderTextStyle : $this->defaultValues['HeaderTextStyle'];
		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>
		<td width='200'>Header Text Style</td><td width='370'>
		<select name='HeaderTextStyle' tabindex='".($maxInvocation->tabindex++)."'>
		<option value=''>Default</option>
		<option value='italic'" . ($HeaderTextStyle == 'italic' ? " selected='selected'" : '') . ">italic</option>
		<option value='normal'" . ($HeaderTextStyle == 'normal' ? " selected='selected'" : '') . ">normal</option>
		<option value='oblique'" . ($HeaderTextStyle == 'oblique' ? " selected='selected'" : '') . ">oblique</option>

		</select>
		<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

		return $option;
    }

	public function FontSize()
    {
        $maxInvocation = &$this->maxInvocation;

        $option = '';
        $option .= "<tr><td width='30'>&nbsp;</td>";
        $option .= "<td width='200'>Font Size for Header text</td><td width='370'>";
        $option .= "<input class='flat' type='text' name='FontSize' size='' value='".(isset($maxInvocation->FontSize) ? htmlspecialchars(stripslashes($maxInvocation->FontSize),ENT_QUOTES) : $this->defaultValues['FontSize'])."' style='width:175px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        return $option;
    }

	public function TextSize()
    {
        $maxInvocation = &$this->maxInvocation;

        $option = '';
        $option .= "<tr><td width='30'>&nbsp;</td>";
        $option .= "<td width='200'>Link Text Size</td><td width='370'>";
        $option .= "<input class='flat' type='text' name='TextSize' size='' value='".(isset($maxInvocation->TextSize) ? htmlspecialchars(stripslashes($maxInvocation->TextSize),ENT_QUOTES) : $this->defaultValues['TextSize'])."' style='width:175px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
        $option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
        return $option;
    }

	public function HeaderFontSize()
	{
		$maxInvocation = &$this->maxInvocation;

		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>";
		$option .= "<td width='200'>Font Size for text</td><td width='370'>";
		$option .= "<input class='flat' type='text' name='HeaderFontSize' size='' value='".(isset($maxInvocation->HeaderFontSize) ? htmlspecialchars(stripslashes($maxInvocation->HeaderFontSize),ENT_QUOTES) : $this->defaultValues['HeaderFontSize'])."' style='width:175px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
		$option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
		return $option;
	}

	public function HeaderFont()
	{
		$maxInvocation = &$this->maxInvocation;
		$HeaderFont = (!empty($maxInvocation->HeaderFont)) ? $maxInvocation->HeaderFont : $this->defaultValues['HeaderFont'];
		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>
		<td width='200'>Header Text Font</td><td width='370'>
		<select name='HeaderFont' tabindex='".($maxInvocation->tabindex++)."'>
		<option value=''>Default</option>
		<option value='Arial, Helvetica, sans-serif'" . ($HeaderFont == 'Arial,Helvetica,sans-serif' ? " selected='selected'" : '') . ">Arial,Helvetica,sans-serif</option>
		<option value='Arial Black,Gadget,sans-serif'" . ($HeaderFont == 'Arial Black,Gadget,sans-serif' ? " selected='selected'" : '') . ">Arial Black,Gadget,sans-serif</option>
		<option value='Comic Sans MS,cursive'" . ($HeaderFont == 'Comic Sans MS,cursive' ? " selected='selected'" : '') . ">Comic Sans MS,cursive</option>
		<option value='Courier New,Courier,monospace'" . ($HeaderFont == 'Courier New,Courier,monospace' ? " selected='selected'" : '') . ">Courier New,Courier,monospace</option>
		<option value='Georgia,serif'" . ($HeaderFont == 'Georgia,serif' ? " selected='selected'" : '') . ">Georgia,serif</option>
		<option value='Impact,Charcoal,sans-serif'" . ($HeaderFont == 'Impact,Charcoal,sans-serif' ? " selected='selected'" : '') . ">Impact,Charcoal,sans-serif</option>
		<option value='Lucida Console,Monaco,monospace'" . ($HeaderFont == 'Lucida Console,Monaco,monospace' ? " selected='selected'" : '') . ">Lucida Console,Monaco,monospace</option>
		<option value='Lucida Sans Unicode,Lucida Grande,sans-serif'" . ($HeaderFont == 'Lucida Sans Unicode,Lucida Grande,sans-serif' ? " selected='selected'" : '') . ">Lucida Sans Unicode,Lucida Grande,sans-serif</option>
		<option value='Palatino Linotype,Book Antiqua,Palatino,serif'" . ($HeaderFont == 'APalatino Linotype,Book Antiqua,Palatino,serif' ? " selected='selected'" : '') . ">Palatino Linotype,Book Antiqua,Palatino,serif</option>
		<option value='Tahoma,Geneva,sans-serif'" . ($HeaderFont == 'Tahoma,Geneva,sans-serif' ? " selected='selected'" : '') . ">Tahoma,Geneva,sans-serif</option>
		<option value='Times New Roman,Times,serif'" . ($HeaderFont == 'Times New Roman,Times,serif' ? " selected='selected'" : '') . ">Times New Roman,Times,serif</option>		
		<option value='Trebuchet MS,Helvetica,sans-serif'" . ($HeaderFont == 'Trebuchet MS,Helvetica,sans-serif' ? " selected='selected'" : '') . ">TTrebuchet MS,Helvetica,sans-serif</option>
		<option value='Verdana,Geneva,sans-serif'" . ($HeaderFont == 'Verdana,Geneva,sans-serif' ? " selected='selected'" : '') . ">Verdana,Geneva,sans-serif</option>
		<option value='Symbol'" . ($HeaderFont == 'Symbol' ? " selected='selected'" : '') . ">Symbol</option>
		<option value='Webdings'" . ($HeaderFont == 'Webdings' ? " selected='selected'" : '') . ">Webdings</option>
		<option value='Wingdings,Zapf Dingbats'" . ($HeaderFont == 'Wingdings,Zapf Dingbats' ? " selected='selected'" : '') . ">Wingdings,Zapf Dingbats</option>
		<option value='MS Sans Serif, Geneva, sans-serif'" . ($HeaderFont == 'MS Sans Serif, Geneva, sans-serif' ? " selected='selected'" : '') . ">MS Sans Serif, Geneva, sans-serif</option>

		<option value='MS Serif, New York, serif'" . ($HeaderFont == 'MS Serif, New York, serif' ? " selected='selected'" : '') . ">MS Serif, New York, serif</option>
		<option value='arial narrow'" . ($HeaderFont == 'arial narrow' ? " selected='selected'" : '') . ">arial narrow</option>
		<option value='verdan'" . ($HeaderFont == 'verdan' ? " selected='selected'" : '') . ">verdan</option>
		</select>
		<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

		return $option;
	}


	public function LinkFont()
    {
		$maxInvocation = &$this->maxInvocation;
		$LinkFont = (!empty($maxInvocation->LinkFont)) ? $maxInvocation->LinkFont : $this->defaultValues['LinkFont'];
		$option = '';
		$option .= "<tr><td width='30'>&nbsp;</td>
		<td width='200'>Link Text Font</td><td width='370'>
		<select name='LinkFont' tabindex='".($maxInvocation->tabindex++)."'>
		<option value=''>Default</option>
		<option value='Arial, Helvetica, sans-serif'" . ($LinkFont == 'Arial,Helvetica,sans-serif' ? " selected='selected'" : '') . ">Arial,Helvetica,sans-serif</option>
		<option value='Arial Black,Gadget,sans-serif'" . ($LinkFont == 'Arial Black,Gadget,sans-serif' ? " selected='selected'" : '') . ">Arial Black,Gadget,sans-serif</option>
		<option value='Comic Sans MS,cursive'" . ($LinkFont == 'Comic Sans MS,cursive' ? " selected='selected'" : '') . ">Comic Sans MS,cursive</option>
		<option value='Courier New,Courier,monospace'" . ($LinkFont == 'Courier New,Courier,monospace' ? " selected='selected'" : '') . ">Courier New,Courier,monospace</option>
		<option value='Georgia,serif'" . ($LinkFont == 'Georgia,serif' ? " selected='selected'" : '') . ">Georgia,serif</option>
		<option value='Impact,Charcoal,sans-serif'" . ($LinkFont == 'Impact,Charcoal,sans-serif' ? " selected='selected'" : '') . ">Impact,Charcoal,sans-serif</option>
		<option value='Lucida Console,Monaco,monospace'" . ($LinkFont == 'Lucida Console,Monaco,monospace' ? " selected='selected'" : '') . ">Lucida Console,Monaco,monospace</option>
		<option value='Lucida Sans Unicode,Lucida Grande,sans-serif'" . ($LinkFont == 'Lucida Sans Unicode,Lucida Grande,sans-serif' ? " selected='selected'" : '') . ">Lucida Sans Unicode,Lucida Grande,sans-serif</option>
		<option value='Palatino Linotype,Book Antiqua,Palatino,serif'" . ($LinkFont == 'APalatino Linotype,Book Antiqua,Palatino,serif' ? " selected='selected'" : '') . ">Palatino Linotype,Book Antiqua,Palatino,serif</option>
		<option value='Tahoma,Geneva,sans-serif'" . ($LinkFont == 'Tahoma,Geneva,sans-serif' ? " selected='selected'" : '') . ">Tahoma,Geneva,sans-serif</option>
		<option value='Times New Roman,Times,serif'" . ($LinkFont == 'Times New Roman,Times,serif' ? " selected='selected'" : '') . ">Times New Roman,Times,serif</option>		
		<option value='Trebuchet MS,Helvetica,sans-serif'" . ($LinkFont == 'Trebuchet MS,Helvetica,sans-serif' ? " selected='selected'" : '') . ">TTrebuchet MS,Helvetica,sans-serif</option>
		<option value='Verdana,Geneva,sans-serif'" . ($LinkFont == 'Verdana,Geneva,sans-serif' ? " selected='selected'" : '') . ">Verdana,Geneva,sans-serif</option>
		<option value='Symbol'" . ($LinkFont == 'Symbol' ? " selected='selected'" : '') . ">Symbol</option>
		<option value='Webdings'" . ($LinkFont == 'Webdings' ? " selected='selected'" : '') . ">Webdings</option>
		<option value='Wingdings,Zapf Dingbats'" . ($LinkFont == 'Wingdings,Zapf Dingbats' ? " selected='selected'" : '') . ">Wingdings,Zapf Dingbats</option>
		<option value='MS Sans Serif, Geneva, sans-serif'" . ($LinkFont == 'MS Sans Serif, Geneva, sans-serif' ? " selected='selected'" : '') . ">MS Sans Serif, Geneva, sans-serif</option>

		<option value='MS Serif, New York, serif'" . ($LinkFont == 'MS Serif, New York, serif' ? " selected='selected'" : '') . ">MS Serif, New York, serif</option>
		<option value='arial narrow'" . ($LinkFont == 'arial narrow' ? " selected='selected'" : '') . ">arial narrow</option>
		<option value='verdan'" . ($LinkFont == 'verdan' ? " selected='selected'" : '') . ">verdan</option>
		</select>
		<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";

		return $option;
    }

	public function headingcolor()
    {
		$maxInvocation = &$this->maxInvocation;
		$path='//'.$GLOBALS['_MAX']['CONF']['webpath']['deliverySSL'].'/jscolor/jscolor.js';
		$option = '';
		$option .= "<script type='text/javascript' src='".$path."'></script><tr><td width='30'>&nbsp;</td>";
		$option .= "<td width='200'>HeaderColor</td><td width='370'>";
		$option .= "<input class='color' type='text' name='headingcolor' size='' value='".(isset($maxInvocation->headingcolor) ? $maxInvocation->headingcolor : $this->defaultValues['headingcolor'])."' style='width:50px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
		$option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
		return $option;
    }


	public function bordercolor()
	{ 
		$maxInvocation = &$this->maxInvocation;
		$path='//'.$GLOBALS['_MAX']['CONF']['webpath']['deliverySSL'].'/jscolor/jscolor.js';
		$option = '';
		$option .= "<script type='text/javascript' src='".$path."'></script><tr><td width='30'>&nbsp;</td>";
		$option .= "<td width='200'>BorderColor</td><td width='370'>";
		$option .= "<input class='color' type='text' name='bordercolor' size='' value='".(isset($maxInvocation->bordercolor) ? $maxInvocation->bordercolor : $this->defaultValues['bordercolor'])."' style='width:50px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
		$option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
		return $option;
    }
    
	public function Linkcolor()
    { 
		$maxInvocation = &$this->maxInvocation;

		$path='//'.$GLOBALS['_MAX']['CONF']['webpath']['deliverySSL'].'/jscolor/jscolor.js';
		$option = '';
		$option .= "<script type='text/javascript' src='".$path."'></script><tr><td width='30'>&nbsp;</td>";
		$option .= "<td width='200'>TextColor</td><td width='370'>";
		$option .= "<input class='color' type='text' name='Linkcolor' size='' value='".(isset($maxInvocation->Linkcolor) ? $maxInvocation->Linkcolor : $this->defaultValues['Linkcolor'])."' style='width:50px;' tabindex='".($maxInvocation->tabindex++)."'></td></tr>";
		$option .= "<tr><td width='30'><img src='" . OX::assetPath(). "/images/spacer.gif' height='5' width='100%'></td></tr>";
		return $option;
    }
    // Reviveadservermod.com - Text Ads end

    /**
     * Return invocation code for this plugin (codetype)
     *
     * @return string
     */
    public function generateInvocationCode()
    {
        $aComments = [
            'Comment' => "",
        ];
        parent::prepareCommonInvocationData($aComments);

        $conf = $GLOBALS['_MAX']['CONF'];
        $mi = &$this->maxInvocation;

        $buffer = $mi->buffer;
        
		if (isset($mi->textFont) && $mi->textFont != '') {
		$mi->parameters['textFont'] = "textFont=".$mi->textFont;
		}

		if (isset($mi->HeaderFont) && $mi->HeaderFont != '') {
		$mi->parameters['HeaderFont'] = "HeaderFont=".$mi->HeaderFont;
		}


		if (isset($mi->TextStyle) && $mi->TextStyle != '') {
		$mi->parameters['TextStyle'] = "TextStyle=".$mi->TextStyle;
		}

		if (isset($mi->HeaderTextStyle) && $mi->HeaderTextStyle != '') {
		$mi->parameters['HeaderTextStyle'] = "HeaderTextStyle=".$mi->HeaderTextStyle;
		}

		if (isset($mi->HeaderFontSize) && $mi->HeaderFontSize != '') {
		$mi->parameters['HeaderFontSize'] = "HeaderFontSize=".$mi->HeaderFontSize;
		}

		if (isset($mi->LinkFont) && $mi->LinkFont != '') {
		$mi->parameters['LinkFont'] = "LinkFont=".$mi->LinkFont;
		}


		if (isset($mi->FontSize) && $mi->FontSize != '') {
		$mi->parameters['FontSize'] = "FontSize=".$mi->FontSize;
		}

		if (isset($mi->TextSize) && $mi->TextSize != '') {
		$mi->parameters['TextSize'] = "TextSize=".$mi->TextSize;
		}

		if (isset($mi->bordercolor) && $mi->bordercolor != '') {
		$mi->parameters['bordercolor'] = "bordercolor=".$mi->bordercolor;
		}
		if (isset($mi->headingcolor) && $mi->headingcolor != '') {
		$mi->parameters['headingcolor'] = "headingcolor=".$mi->headingcolor;
		}

		if (isset($mi->Linkcolor) && $mi->Linkcolor != '') {
		$mi->parameters['Linkcolor'] = "Linkcolor=".$mi->Linkcolor;
		}

		if (isset($mi->block) && $mi->block == '1') {
		$mi->parameters['block'] = "block=1";
		}
		if (isset($mi->blockcampaign) && $mi->blockcampaign == '1') {
		$mi->parameters['blockcampaign'] = "blockcampaign=1";
		}

        // The cachebuster for async tags isn't needed
        unset($mi->parameters['cb']);

        // Add ID
        $mi->parameters['id'] = 'id=' . md5("{$conf['webpath']['delivery']}*{$conf['webpath']['deliverySSL']}")."tg";
		// Contextual Targeting - Start
		$mi->parameters['keyword'] = 'keyword={keyword}';
		// Contextual Targeting - End
        // Remap as tag attributes with data-revive prefix
        $mi->parameters = array_map(function ($v) use ($conf) {
            return preg_replace('#^(.*)=(.*)$#', 'data-' . $conf['var']['product'] . '-$1="$2"', $v);
        }, $mi->parameters);

        $buffer .= '<ins ' . join(' ', $mi->parameters) . '></ins>' . PHP_EOL;
        if ($conf['webpath']['delivery'] === $conf['webpath']['deliverySSL']) {
            // Yes, we can use the short version!
            $buffer .= '<script async src="' . MAX_commonConstructPartialDeliveryUrl("textasyncjs.php") . '"></script>';
        } else {
            // Bummer, we need the longer variant
            $url = [
                MAX_commonConstructDeliveryUrl($conf['file']['asyncjs']),
                MAX_commonConstructSecureDeliveryUrl($conf['file']['asyncjs']),
            ];
            $buffer .= <<<EOF
<script>
(function () {
  var d = document, s = d.createElement('script'), p = d.location.protocol,
      i = d.getElementsByTagName('ins'), j = i[i.length-1];
  try {
    s.src = p === 'http:' ? '{$url[0]}' :
      '{$url[1]}';
    s.async = true; j.appendChild(s);
  } catch (e) {}
})();
</script>
EOF;
        }

        return $buffer;
    }

    public function setInvocation(&$invocation)
    {
        $this->maxInvocation = &$invocation;
        $this->maxInvocation->canDetectCharset = true;
    }

    public function generateWebsiteInvocationCode(): string
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        $pref = $GLOBALS['_MAX']['CONF'];

        $mi = &$this->maxInvocation;

        // Get the affiliate information
        $doAffiliates = OA_Dal::factoryDO('affiliates');
        if ($doAffiliates->get($mi->affiliateid)) {
            $affiliate = $doAffiliates->toArray();
        }
        $doZones = OA_Dal::factoryDO('zones');
        $doZones->affiliateid = $mi->affiliateid;
        $doZones->find();
        while ($doZones->fetch() && $row = $doZones->toArray()) {
            // Email/Newsletter and DHTML and Video zones are not included in SPC
            if ($row['delivery'] != MAX_ZoneEmail
                && $row['delivery'] != phpAds_ZoneInterstitial
                && $row['delivery'] != OX_ZoneVideoInstream
                && $row['delivery'] != OX_ZoneVideoOverlay) {
                $aZones[] = $row;
            }
        }

        if (empty($aZones)) {
            return 'No Zones Available!';
        }


        $channel = (!empty($mi->source)) ? $mi->source : $affiliate['mnemonic'] . "/test/preview";

        $script = "<?xml version='1.0' encoding='UTF-8' ?><!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'>
<head>
    <title>Tags for [id{$affiliate['affiliateid']}] " . htmlspecialchars($affiliate['name']) . "</title>
        <link rel='stylesheet' type='text/css' href='" . OX::assetPath() . "/css/preview.css' />
        <script type='text/javascript' src='" . OX::assetPath() . "/js/jquery-1.2.3.js'></script>

        <script type='text/javascript'>
        <!--

            function selectElement() {
                if (window.getSelection) {
                    var r = document.createRange();
                    r.selectNodeContents($(this)[0]);
                    var s = window.getSelection();
                    if (s.rangeCount) {
                        s.collapseToStart();
                        s.removeAllRanges();
                    }
                    s.addRange(r);
                } else if (document.body.createTextRange) {
                    var r = document.body.createTextRange();
                    r.moveToElementText($(this)[0]);
                    r.select();
                }
            }

            $(document).ready(function() {
                $('pre').bind('mousedown', selectElement);
                $('pre').bind('click', selectElement);
                $('pre').bind('mousemove', selectElement);

                $('#closeWindow').click(function() {
                    window.close();
                });
            });

        //-->
        </script>
    </head>

    <body class='invocationCodes'>
        <div class='header'>
            <h1>" . PRODUCT_NAME . "</h1>
        </div>
        ";

        $script .= "
        <div class='settings'>
            <h2>Tags <small>for <span class='inlinePublisher'>[id{$affiliate['affiliateid']}] " . htmlspecialchars($affiliate['name']) . "</span></small></h2>
            <p>
                This page contains all the information you need to show banners on your website.
                Please follow the instructions carefully and ensure that you copied the scripts <strong>exactly</strong> as shown below.
            </p>

            <h3>The following settings were used to generate this page:</h3>
            <table class='horizontalSummary' summary=''>
        ";

        reset($this->defaultOptionValues);
        foreach ($this->defaultOptionValues as $feature => $default) {
            switch ($feature) {
                case 'block':
                    $optionName = $GLOBALS['strInvocationDontShowAgain'];
                    $optionValue = intval($mi->$feature) ? $GLOBALS['strYes'] : $GLOBALS['strNo'];
                    break;
                case 'blockcampaign':
                    $optionName = $GLOBALS['strInvocationDontShowAgainCampaign'];
                    $optionValue = intval($mi->$feature) ? $GLOBALS['strYes'] : $GLOBALS['strNo'];
                    break;
                case 'target':
                    $optionName = $GLOBALS['strInvocationTarget'];
                    switch ($mi->$feature) {
                        case '_blank':  $optionValue = 'New window'; break;
                        case '_top':    $optionValue = 'Same window'; break;
                        default:        $optionValue = $GLOBALS['strDefault']; break;
                    }
                    break;
                case 'source':
                    $optionName = $GLOBALS['strInvocationSource'];
                    $optionValue = $mi->$feature != '' ? htmlspecialchars(stripslashes($mi->$feature)) : '-';
                    break;
                default:
                    $optionName = $feature;
                    $optionValue = htmlspecialchars(stripslashes($mi->$feature));
                    break;
            }

            $script .= "
                <tr>
                    <th>{$optionName}</th>
                    <td>{$optionValue}</td>
                </tr>
            ";
        }

        $script .= "
            </table>
        </div>
        ";

        $i = 1;
        foreach ($aZones as $zone) {
            $codeblock = $this->getZoneCode($zone, $affiliate);

            $inlineZoneClass = $zone['delivery'] == phpAds_ZoneText ? 'textZone' : '';

            $script .= "
        <div class='step'>
            <h2>
                <div class='number'><span>{$i}</span></div>
                Ad script <small>for <span class='inlineZone {$inlineZoneClass}'>[id{$zone['zoneid']}] " . htmlspecialchars($zone['zonename']) . "</span></small>
            </h2>
            <p>
                Copy the following script and place it in the site where you want the ad to display:
            </p>

            <pre>" . htmlspecialchars($codeblock) . "</pre>
                ";

            if ($zone['delivery'] == phpAds_ZoneBanner) {
                $script .= "
            <p>
                Example" . ($zone['width'] == -1 || $zone['height'] == -1 ? ' (actual size may vary)' : '') . ":
            </p>
            ";
                $width = $zone['width'] > -1 ? $zone['width'] : 150;
                $widthLabel = $zone['width'] > -1 ? $zone['width'] : '*';

                $height = $zone['height'] > -1 ? $zone['height'] : 150;
                $heightLabel = $zone['height'] > -1 ? $zone['height'] : '*';

                $customClass = [];

                if ($zone['width'] == -1 && $zone['height'] == -1) {
                    $customClass[] = 'customBoth';
                } elseif ($zone['height'] == -1) {
                    $customClass[] = 'customHeight';
                } elseif ($zone['width'] == -1) {
                    $customClass[] = 'customWidth';
                }

                // Labels are roughly 80 x 30 pixels...
                // width < 80 || height < 30 => No room for even a single label, drop the OpenX logo and show the size outside
                // width < 160 && height < 60   => No room for both labels... drop the OpenX logo
                if (($zone['width'] > -1 && $zone['width'] < 80) || ($zone['height'] > -1 && $zone['height'] < 30)) {
                    $customClass[] = 'labelsMicro';
                } elseif ($zone['width'] > -1 && $zone['width'] < 160 && $zone['height'] > -1 && $zone['height'] < 60) {
                    $customClass[] = 'labelsMini';
                }

                $script .= "
            <div class='sizePreview " . (count($customClass) ? ' ' . implode(' ', $customClass) : '') . "' style='width: {$width}px; height: {$height}px;'>
                <img src='" . OX::assetPath() . "/images/logo-adserver-small.png' alt='' />
                <span>{$widthLabel} x {$heightLabel}</span>
            </div>
                ";
            }

            $script .= "
        </div>
            ";

            $i++;
        }

        $script .= "
        <div class='step'>
            <h2>
                <div class='number'><span>{$i}</span></div>
                Done
            </h2>
            <p>
                Banners should now appear on your website
            </p>

            <button id='closeWindow'><img src='" . OX::assetPath() . "/images/cross.png' alt='' />Close this window</button>
        </div>
    </body>
</html>
        ";

        return $script;
    }

    public function isWebsiteDefault(): bool
    {
        return true;
    }

    private function getZoneCode($zone, $affiliate, $zoneAlias = null): string
    {
        $mi = &$this->maxInvocation;
        $conf = $GLOBALS['_MAX']['CONF'];

        $zone['n'] = $affiliate['mnemonic'] . substr(md5(uniqid('', 1)), 0, 7);

        $mi->zoneid = $zone['zoneid'];

        return $this->generateInvocationCode();
    }
}
